Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.datasource
Class DataSourceTransactionManager

    java.lang.Object
      org.springframework.transaction.support.AbstractPlatformTransactionManager
          org.springframework.jdbc.datasource.DataSourceTransactionManager

All Implemented Interfaces:
  java.io.Serializable, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

    public class DataSourceTransactionManager

extends AbstractPlatformTransactionManager
implements ResourceTransactionManager, InitializingBean

`PlatformTransactionManager` implementation for a single JDBC `DataSource`. This class is capable of working in any environment with any JDBC driver, as long as the setup uses a JDBC 2.0 Standard Extensions / JDBC 3.0 `javax.sql.DataSource` as its Connection factory mechanism. Binds a JDBC Connection from the specified DataSource to the current thread, potentially allowing for one thread-bound Connection per DataSource.

Note: The DataSource that this transaction manager operates on needs to return independent Connections. The Connections may come from a pool (the typical case), but the DataSource must not return thread-scoped / request-scoped Connections or the like. This transaction manager will associate Connections with thread-bound transactions itself, according to the specified propagation behavior. It assumes that a separate, independent Connection can be obtained even during an ongoing transaction.

Application code is required to retrieve the JDBC Connection via `DataSourceUtils.getConnection(DataSource)` instead of a standard J2EE-style `DataSource.getConnection()` call. Spring classes such as `JdbcTemplate` use this strategy implicitly. If not used in combination with this transaction manager, the `DataSourceUtils` lookup strategy behaves exactly like the native DataSource lookup; it can thus be used in a portable fashion.

Alternatively, you can allow application code to work with the standard J2EE-style lookup pattern `DataSource.getConnection()`, for example for legacy code that is not aware of Spring at all. In that case, define a `TransactionAwareDataSourceProxy` for your target DataSource, and pass that proxy DataSource to your DAOs, which will automatically participate in Spring-managed transactions when accessing it.

Supports custom isolation levels, and timeouts which get applied as appropriate JDBC statement timeouts. To support the latter, application code must either use `JdbcTemplate`, call `DataSourceUtils.applyTransactionTimeout(java.sql.Statement, javax.sql.DataSource)` for each created JDBC Statement, or go through a `TransactionAwareDataSourceProxy` which will create timeout-aware JDBC Connections and Statements automatically.

Consider defining a `LazyConnectionDataSourceProxy` for your target DataSource, pointing both this transaction manager and your DAOs to it. This will lead to optimized handling of "empty" transactions, i.e. of transactions without any JDBC statements executed. A LazyConnectionDataSourceProxy will not fetch an actual JDBC Connection from the target DataSource until a Statement gets executed, lazily applying the specified transaction settings to the target Connection.

On JDBC 3.0, this transaction manager supports nested transactions via the JDBC 3.0 `Savepoint` mechanism. The `"nestedTransactionAllowed"` flag defaults to "true", since nested transactions will work without restrictions on JDBC drivers that support savepoints (such as the Oracle JDBC driver).

This transaction manager can be used as a replacement for the `JtaTransactionManager` in the single resource case, as it does not require a container that supports JTA, typically in combination with a locally defined JDBC DataSource (e.g. a Jakarta Commons DBCP connection pool). Switching between this local strategy and a JTA environment is just a matter of configuration!

Since:
  02.05.2003
Author:
  Juergen Hoeller
See Also:
  `AbstractPlatformTransactionManager.setNestedTransactionAllowed(boolean)`, `Savepoint`, `DataSourceUtils.getConnection(javax.sql.DataSource)`, `DataSourceUtils.applyTransactionTimeout(java.sql.Statement, javax.sql.DataSource)`, `DataSourceUtils.releaseConnection(java.sql.Connection, javax.sql.DataSource)`, `TransactionAwareDataSourceProxy`, `LazyConnectionDataSourceProxy`, `JdbcTemplate`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`AbstractPlatformTransactionManager.SuspendedResourcesHolder`

Field Summary

Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

Constructor Summary
`DataSourceTransactionManager()` Create a new DataSourceTransactionManager instance.
`DataSourceTransactionManager(javax.sql.DataSource dataSource)` Create a new DataSourceTransactionManager instance.

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected void` | `doBegin(java.lang.Object transaction, TransactionDefinition definition)` This implementation sets the isolation level but ignores the timeout.
`protected void` | `doCleanupAfterCompletion(java.lang.Object transaction)` Cleanup resources after transaction completion.
`protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
`protected java.lang.Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
`protected void` | `doResume(java.lang.Object transaction, java.lang.Object suspendedResources)` Resume the resources of the current transaction.
`protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
`protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
`protected java.lang.Object` | `doSuspend(java.lang.Object transaction)` Suspend the resources of the current transaction.
`javax.sql.DataSource` | `getDataSource()` Return the JDBC DataSource that this instance manages transactions for.
`java.lang.Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g.
`protected boolean` | `isExistingTransaction(java.lang.Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
`void` | `setDataSource(javax.sql.DataSource dataSource)` Set the JDBC DataSource that this instance should manage transactions for.

Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareForCommit, prepareSynchronization, prepareTransactionStatus, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, shouldCommitOnGlobalRollbackOnly, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.springframework.transaction.PlatformTransactionManager
`commit, getTransaction, rollback`

Constructor Detail

### DataSourceTransactionManager

    public DataSourceTransactionManager()

  Create a new DataSourceTransactionManager instance. A DataSource has to be set to be able to use it.

  See Also:
    `setDataSource(javax.sql.DataSource)`

### DataSourceTransactionManager

    public DataSourceTransactionManager(javax.sql.DataSource dataSource)

  Create a new DataSourceTransactionManager instance.

  Parameters:
    `dataSource` - JDBC DataSource to manage transactions for

Method Detail

### setDataSource

    public void setDataSource(javax.sql.DataSource dataSource)

  Set the JDBC DataSource that this instance should manage transactions for.

  This will typically be a locally defined DataSource, for example a Jakarta Commons DBCP connection pool. Alternatively, you can also drive transactions for a non-XA J2EE DataSource fetched from JNDI. For an XA DataSource, use JtaTransactionManager.

  The DataSource specified here should be the target DataSource to manage transactions for, not a TransactionAwareDataSourceProxy. Only data access code may work with TransactionAwareDataSourceProxy, while the transaction manager needs to work on the underlying target DataSource. If there's nevertheless a TransactionAwareDataSourceProxy passed in, it will be unwrapped to extract its target DataSource.

  The DataSource passed in here needs to return independent Connections. The Connections may come from a pool (the typical case), but the DataSource must not return thread-scoped / request-scoped Connections or the like.

  See Also:
    `TransactionAwareDataSourceProxy`, `JtaTransactionManager`

### getDataSource

    public javax.sql.DataSource getDataSource()

  Return the JDBC DataSource that this instance manages transactions for.

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getResourceFactory

    public java.lang.Object getResourceFactory()

  Description copied from interface: `ResourceTransactionManager`
  Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

  This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

  Specified by:
    `getResourceFactory` in interface `ResourceTransactionManager`
  Returns:
    the target resource factory (never `null`)
  See Also:
    `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

### doGetTransaction

    protected java.lang.Object doGetTransaction()

  Description copied from class: `AbstractPlatformTransactionManager`
  Return a transaction object for the current transaction state.

  The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

  The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

  Specified by:
    `doGetTransaction` in class `AbstractPlatformTransactionManager`
  Returns:
    the current transaction object
  See Also:
    `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

### isExistingTransaction

    protected boolean isExistingTransaction(java.lang.Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

  The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

  The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `isExistingTransaction` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by doGetTransaction
  Returns:
    if there is an existing transaction
  See Also:
    `AbstractPlatformTransactionManager.doGetTransaction()`

### doBegin

    protected void doBegin(java.lang.Object transaction,
                           TransactionDefinition definition)

  This implementation sets the isolation level but ignores the timeout.

  Specified by:
    `doBegin` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

### doSuspend

    protected java.lang.Object doSuspend(java.lang.Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doSuspend` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
  Returns:
    an object that holds suspended resources (will be kept unexamined for passing it into doResume)
  See Also:
    `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

### doResume

    protected void doResume(java.lang.Object transaction,
                            java.lang.Object suspendedResources)

  Description copied from class: `AbstractPlatformTransactionManager`
  Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doResume` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
  See Also:
    `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

### doCommit

    protected void doCommit(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual commit of the given transaction.

  An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doCommit` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doRollback

    protected void doRollback(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual rollback of the given transaction.

  An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doRollback` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doSetRollbackOnly

    protected void doSetRollbackOnly(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

  The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction

### doCleanupAfterCompletion

    protected void doCleanupAfterCompletion(java.lang.Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Cleanup resources after transaction completion.

  Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

  Should not throw any exceptions but just issue warnings on errors.

  Overrides:
    `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD